__gnu_debug::_Safe_sequence< _Sequence >(3cxx)

NAME
__gnu_debug::_Safe_sequence< _Sequence > - Base class for constructing a safe sequence type that tracks iterators that reference it.

SYNOPSIS

Inherited by __gnu_debug::_Safe_node_sequence< _Sequence >.

  Public Member Functions

template<typename _Predicate > void _M_invalidate_if (_Predicate __pred)
template<typename _Predicate > void _M_transfer_from_if (_Safe_sequence &__from, _Predicate __pred)

Detailed Description

  template<typename _Sequence>
class __gnu_debug::_Safe_sequence< _Sequence >" Base class for constructing a safe sequence type that tracks iterators that reference it.

The class template _Safe_sequence simplifies the construction of safe sequences that track the iterators that reference the sequence, so that the iterators are notified of changes in the sequence that may affect their operation, e.g., if the container invalidates its iterators or is destructed. This class template may only be used by deriving from it and passing the name of the derived class as its template parameter via the curiously recurring template pattern. The derived class must have iterator and const_iterator types that are instantiations of class template _Safe_iterator for this sequence. Iterators will then be tracked automatically.

Definition at line 62 of file formatter.h.

Member Function Documentation

  template<typename _Sequence > template<typename _Predicate > void __gnu_debug::_Safe_sequence< _Sequence >::_M_invalidate_if (_Predicate __pred)
Invalidates all iterators x that reference this sequence, are not singular, and for which __pred(x) returns true. __pred will be invoked with the normal iterators nested in the safe ones.

Definition at line 38 of file safe_sequence.tcc.

  template<typename _Sequence > template<typename _Predicate > void __gnu_debug::_Safe_sequence< _Sequence >::_M_transfer_from_if (_Safe_sequence< _Sequence > & __from, _Predicate __pred)
Transfers all iterators x that reference from sequence, are not singular, and for which __pred(x) returns true. __pred will be invoked with the normal iterators nested in the safe ones.

Definition at line 69 of file safe_sequence.tcc.

Author

Generated automatically by Doxygen for libstdc++ from the source code.